package com.nominanuda.springfreemarker;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import javax.servlet.http.HttpServletResponse;

import org.springframework.web.servlet.view.freemarker.FreeMarkerView;

import com.nominanuda.web.http.HttpProtocol;

import freemarker.template.SimpleHash;
import freemarker.template.Template;
import freemarker.template.TemplateException;

public final class FreeMarkerViewImpl extends FreeMarkerView implements HttpProtocol {
	private static final int INITIAL_BUFFER_SIZE = 8 * 1024;

	@Override
	protected final void processTemplate(Template template, SimpleHash model, HttpServletResponse response) throws IOException, TemplateException {
		ByteArrayOutputStream out = new ByteArrayOutputStream(INITIAL_BUFFER_SIZE);
		template.process(model, new OutputStreamWriter(out, UTF_8));
		response.setContentLength(out.size());
		out.writeTo(response.getOutputStream());
	}
}